hdu 1839 Delay Constrained Maximum Capacity Path(spfa+二分)

Delay Constrained Maximum Capacity Path

Time Limit: 10000/10000 MS (Java/Others)    Memory Limit: 65535/65535 K (Java/Others)
Total Submission(s): 1790    Accepted Submission(s):
577

Problem Description

Consider an undirected graph with N vertices, numbered
from 1 to N, and M edges. The vertex numbered with 1 corresponds to a mine from
where some precious minerals are extracted. The vertex numbered with N
corresponds to a minerals processing factory. Each edge has an associated travel
time (in time units) and capacity (in units of minerals). It has been decided
that the minerals which are extracted from the mine will be delivered to the
factory using a single path. This path should have the highest capacity
possible, in order to be able to transport simultaneously as many units of
minerals as possible. The capacity of a path is equal to the smallest capacity
of any of its edges. However, the minerals are very sensitive and, once
extracted from the mine, they will start decomposing after T time units, unless
they reach the factory within this time interval. Therefore, the total travel
time of the chosen path (the sum of the travel times of its edges) should be
less or equal to T.

Input

The first line of input contains an integer number X,
representing the number of test cases to follow. The first line of each test
case contains 3 integer numbers, separated by blanks: N (2 <= N <=
10.000), M (1 <= M <= 50.000) and T (1 <= T <= 500.000). Each of the
next M lines will contain four integer numbers each, separated by blanks: A, B,
C and D, meaning that there is an edge between vertices A and B, having capacity
C (1 <= C <= 2.000.000.000) and the travel time D (1 <= D <=
50.000). A and B are different integers between 1 and N. There will exist at
most one edge between any two vertices.

Output

For each of the X test cases, in the order given in the
input, print one line containing the highest capacity of a path from the mine to
the factory, considering the travel time constraint. There will always exist at
least one path between the mine and the factory obbeying the travel time
constraint.

Sample Input

2

2 1 10

1 2 13 10

4 4 20

1 2 1000 15

2 4 999 6

1 3 100 15

3 4 99 4

Sample Output

13

99

Author

Mugurel Ionut Andreica

题意:有N个点,点1为珍贵矿物的采矿区, 点N为加工厂,有M条双向连通的边连接这些点。走每条边的运输容量为C,运送时间为D。他们要选择一条从1到N的路径运输, 这条路径的运输总时间要在T之内,在这个前提之下,要让这条路径的运输容量尽可能地大。每条路径的运输容量取决与这条路径中的运输容量最小的那条边。

使用二分枚举,因为资源越多,能走的路就越少,因此使用二分从大到小排序之后枚举。

附上代码:

  1 #include <iostream>
  2 #include <cstdio>
  3 #include <cstring>
  4 #include <queue>
  5 #include <algorithm>
  6 #define INF 0x3f3f3f3f
  7 #define M 50005
  8 #define N 10005
  9 using namespace std;
 10
 11 int tol,n,m,t,limit;
 12 struct Edge
 13 {
 14     int form,to,val,time;
 15     int next;
 16 } edge[M*2];
 17
 18 int head[M*2],dis[N],r[M];
 19 bool vis[N];
 20
 21 bool cmp(int a,int b)
 22 {
 23     return a>b;
 24 }
 25
 26 void init()
 27 {
 28     tol=0;
 29     memset(head,-1,sizeof(head));
 30 }
 31
 32 void addEdge(int u,int v,int val,int time) ///邻接表
 33 {
 34     edge[tol].form=u;
 35     edge[tol].to=v;
 36     edge[tol].val=val;
 37     edge[tol].time=time;
 38     edge[tol].next=head[u];
 39     head[u]=tol++;
 40     edge[tol].form=v;
 41     edge[tol].to=u;
 42     edge[tol].val=val;
 43     edge[tol].time=time;
 44     edge[tol].next=head[v];
 45     head[v]=tol++;
 46 }
 47
 48 void getmap()
 49 {
 50     scanf("%d%d%d",&n,&m,&t);
 51     int a,b,c,d;
 52     for(int i=0; i<m; i++)
 53     {
 54         scanf("%d%d%d%d",&a,&b,&c,&d);
 55         r[i]=c;
 56         addEdge(a,b,c,d);
 57     }
 58     sort(r,r+m,cmp); ///从大到小排序
 59
 60 }
 61
 62 int spfa() ///求最短时间
 63 {
 64     memset(dis,INF,sizeof(dis));
 65     memset(vis,false,sizeof(vis));
 66     queue<int>q;
 67     q.push(1);
 68     dis[1]=0;
 69     vis[1]=true;
 70     while(!q.empty())
 71     {
 72         int u=q.front();
 73         q.pop();
 74         vis[u]=false;
 75         for(int i=head[u]; i!=-1; i=edge[i].next)
 76         {
 77             int v=edge[i].to;
 78             if(edge[i].val>=limit)
 79                 if(dis[v]>dis[u]+edge[i].time)
 80                 {
 81                     dis[v]=dis[u]+edge[i].time;
 82                     if(!vis[v])
 83                     {
 84                         vis[v]=true;
 85                         q.push(v);
 86                     }
 87                 }
 88         }
 89     }
 90     return dis[n];
 91 }
 92
 93
 94
 95 void search()
 96 {
 97     int left=0,right=m-1,mid;
 98     while(left<right) ///二分
 99     {
100         mid=(left+right)/2;
101         limit=r[mid];
102         int tmp=spfa();
103         if(tmp==INF||tmp>t)
104             left=mid+1;
105         else
106             right=mid;
107     }
108     printf("%d\n",r[left]);
109 }
110
111 int main()
112 {
113     int T;
114     scanf("%d",&T);
115     while(T--)
116     {
117         init();
118         getmap();
119         search();
120     }
121     return 0;
122 }
时间: 2024-10-17 13:54:50

hdu 1839 Delay Constrained Maximum Capacity Path(spfa+二分)的相关文章

HDU 1839 Delay Constrained Maximum Capacity Path(二分+最短路)

题目地址:HDU 1839 我去..原来这题这么简单...网络流中这种二分建图的方式做了一大堆了..这种题还能难倒我吗...白天一直没怎么看懂题,对题意懵懵懂懂的...晚上好好看了看题,这不就是网络流中练的最多的那种二分建图模型吗....只是把网络流算法改成最短路就行了..但是两个地方手残了没能在实验室当场A掉..sad... 这题就是二分最小容量,对满足容量的加边,对时间求最短路.如果最短时间比规定时间少的话就可以继续增加容量,直到不能增加为止. 代码如下: #include <iostrea

hdu 1839 Delay Constrained Maximum Capacity Path

最短路+二分. 对容量进行二分,因为容量和时间是单调关系的,容量越多,能用的边越少,时间会不变或者增加. 因为直接暴力一个一个容量去算会TLE,所以采用二分. #include<cstdio> #include<vector> #include<cstring> #include<queue> #include<map> #include<algorithm> using namespace std; const int maxn =

【HDU 1839】 Delay Constrained Maximum Capacity Path(二分+最短路)

[HDU 1839] Delay Constrained Maximum Capacity Path(二分+最短路) Delay Constrained Maximum Capacity Path Time Limit: 10000/10000 MS (Java/Others)    Memory Limit: 65535/65535 K (Java/Others) Total Submission(s): 1515    Accepted Submission(s): 481 Problem

复习图---Delay Constrained Maximum Capacity Path(SPFA+二分)

Delay Constrained Maximum Capacity Path Time Limit:10000MS     Memory Limit:65535KB     64bit IO Format:%I64d & %I64u Submit Status Description Consider an undirected graph with N vertices, numbered from 1 to N, and M edges. The vertex numbered with

HDU1839Delay Constrained Maximum Capacity Path(二分答案+SPFA)经典

Delay Constrained Maximum Capacity Path Time Limit: 10000/10000 MS (Java/Others)    Memory Limit: 65535/65535 K (Java/Others) Total Submission(s): 1314    Accepted Submission(s): 418 Problem Description Consider an undirected graph with N vertices, n

HDU1839_Delay Constrained Maximum Capacity Path(最短路+二分)

解题报告 http://blog.csdn.net/juncoder/article/details/38349019 题目传送门 题意: 有N个点,点1为珍贵矿物的采矿区, 点N为加工厂,有M条双向连通的边连接这些点.走每条边的运输容量为C,运送时间为D. 他们要选择一条从1到N的路径运输, 这条路径的运输总时间要在T之内,在这个前提之下,要让这条路径的运输容量尽可能地大. 一条路径的运输容量取决与这条路径中的运输容量最小的那条边. 思路: 二分容量建图,spfa判时间是否符合条件 #incl

hdu1839Delay Constrained Maximum Capacity Path 二分+最短路

//一个无向图,两点之间的流量为c,两点花的时间为t //问从起点到终点n之间时间小于等于T且只走一条路径能够运输的最大流量为多少 //二分流量,小于这个流量的路径不走,求其时间是否小于等于T得到答案 #include<cstdio> #include<cstring> #include<iostream> #include<queue> using namespace std ; const int maxn = 10010 ; const int max

HDU 4002 Find the maximum(数论-欧拉函数)

Find the maximum Problem Description Euler's Totient function, φ (n) [sometimes called the phi function], is used to determine the number of numbers less than n which are relatively prime to n . For example, as 1, 2, 4, 5, 7, and 8, are all less than

POJ 3126 Prime Path SPFA

http://poj.org/problem?id=3126 题目大意: 给你两个四位的素数s和t,要求每次改变一个数字,使得改变后的数字也为素数,求s变化到t的最少变化次数. 思路: 首先求出所有4位素数. 对于两个素数之间,如果只相差一个数字,那么就建立图,(双向) 最后求最短路即可(可以SPFA也可以BFS) #include<cstdio> #include<cstring> #include<queue> #include<algorithm> u